package org.eclipse.jdt.internal.compiler.lookup;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.eclipse.jdt.internal.compiler.lookup.Binding;
import org.eclipse.jdt.internal.compiler.lookup.InferenceSubstitution;
import org.eclipse.jdt.internal.compiler.lookup.InferenceVariable;
import org.eclipse.jdt.internal.compiler.lookup.InvocationSite;
import org.eclipse.jdt.internal.compiler.lookup.LookupEnvironment;
import org.eclipse.jdt.internal.compiler.lookup.MethodBinding;
import org.eclipse.jdt.internal.compiler.lookup.TypeBinding;
import org.eclipse.jdt.internal.compiler.lookup.TypeVariableBinding;

class null extends InferenceSubstitution {
  null(LookupEnvironment $anonymous0, InferenceVariable[] $anonymous1, InvocationSite $anonymous2) {
    super($anonymous0, $anonymous1, $anonymous2);
  }
  
  protected boolean isSameParameter(TypeBinding p1, TypeBinding originalType) {
    if (TypeBinding.equalsEquals(p1, originalType))
      return true; 
    if (p1 instanceof TypeVariableBinding && originalType instanceof TypeVariableBinding) {
      MethodBinding methodBinding1, methodBinding2;
      TypeVariableBinding var1 = (TypeVariableBinding)p1, var2 = (TypeVariableBinding)originalType;
      Binding declaring1 = var1.declaringElement;
      Binding declaring2 = var2.declaringElement;
      if (declaring1 instanceof MethodBinding && declaring2 instanceof MethodBinding) {
        methodBinding1 = ((MethodBinding)declaring1).original();
        methodBinding2 = ((MethodBinding)declaring2).original();
      } 
      return (methodBinding1 == methodBinding2 && var1.rank == var2.rank);
    } 
    return false;
  }
}
